#include "Player.h"
#include "Glob.h"
#include <iostream>
#include <list>

extern Glob* glob;


Player::Player(int ID)
{
	m_ID = ID;
	m_DiscoveredRoomTypes.push_back(PLAYERBASE);
	m_DiscoveredRoomTypes.push_back(LOOK);
	m_DiscoveredRoomTypes.push_back(ROCK);
	m_DiscoveredRoomTypes.push_back(PING);
	m_DiscoveredRoomTypes.push_back(FORAGE);
	m_Risk = 100;
	m_Alive = true;
	
	Object* tempobj;
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(LOOK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(PING,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "lp";
	m_Templates.push_back(tempobj);
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(FORAGE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(PING,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "fp";
	m_Templates.push_back(tempobj);
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(LOOK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(ROCK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "lR";
	m_Templates.push_back(tempobj);
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(LOOK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(ROCK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(PING,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "lRp";
	m_Templates.push_back(tempobj);
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(LOOK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(BPAPER,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "lRp";
	m_Templates.push_back(tempobj);
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(LOOK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(BPAPER,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(PING,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "lRp";
	m_Templates.push_back(tempobj);
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(LOOK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(XSCISSORS,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "lRp";
	m_Templates.push_back(tempobj);
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(LOOK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(XSCISSORS,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(PING,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "lRp";
	m_Templates.push_back(tempobj);
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(LOOK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(ROCK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(ROCK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "lRp";
	m_Templates.push_back(tempobj);
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(LOOK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(ASCREAM,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "lRp";
	m_Templates.push_back(tempobj);
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(LOOK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(PING,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "lRp";
	m_Templates.push_back(tempobj);
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(LOOK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(ASEEKSCREAM,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(ROCK,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "lRp";
	m_Templates.push_back(tempobj);
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(SNOOP,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(PING,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "lRp";
	m_Templates.push_back(tempobj);
	
	tempobj = new Object();
	tempobj->m_Rooms.push_back( new Room(PLAYERBASE,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(SNOOP,sf::FloatRect(0,0,0,0)) );
	tempobj->m_Rooms.push_back( new Room(PING,sf::FloatRect(0,0,0,0)) );
	tempobj->m_PlayerID = m_ID;
	tempobj->m_VisibleToPlayer = 1.0;
	tempobj->m_Name = "lRp";
	m_Templates.push_back(tempobj);
}

Object* Player::AI()
{
	if (rand()%10 != 1) return NULL;
	
	Object* tmpobj = m_Templates[rand()%m_Templates.size()];
		
	for (std::vector<Room*>::iterator room=tmpobj->m_Rooms.begin();room!=tmpobj->m_Rooms.end();++room)
	{
		bool available = false;
		
		for (std::vector<RoomType>::iterator type=m_DiscoveredRoomTypes.begin();type!=m_DiscoveredRoomTypes.end();++type)
		{
			if ((*type) == (*room)->Type) 
			{
				available = true;
				break;
			}
		}
		if (!available)	return NULL;
	}
	
	return tmpobj->Spawn();
	
	/*
	std::vector<Object*> creations;
	
	Object* 

	
	*/
	/*
	
	lp
	fp
	lR
	lRp
	lB
	lBp
	lX
	lXp
	lRR
	lA
	lp
	laR
	mTC
	sp
	
	*/
	
	
}
