#ifndef RENDER_H
#define RENDER_H

#include <SFGUI/SFGUI.hpp>
#include <SFML/System.hpp>
#include <SFML/Graphics.hpp>

#include "Glob.h"

class Render
{
public:
	bool Init();
	bool Loop();
	bool Register(sfg::Window::Ptr);
	
	void BringToFront(sfg::Window::Ptr);

	sfg::SFGUI m_GUI;
	sf::RenderWindow m_RenderWindow;
	sfg::Desktop m_Desktop;
	
	sf::Event m_Event;
	sf::Clock m_Clock;
};

#endif