#ifndef CREATEBAR_H
#define CREATEBAR_H

#include <stdlib.h>
#include <vector>

#include <SFGUI/SFGUI.hpp>
#include <SFML/Graphics.hpp>

#include "BarButton.h"

class CreateBar
{
public:
	sfg::Window::Ptr GetPointer();
	bool Init();
	BarButton* AddNewButton();
	void RemoveNewButton();
	void RemoveButton(int);
	
	void PokeButton(int);
	
private:
	sfg::Window::Ptr m_Window;
	sfg::Fixed::Ptr m_Fixed;
	sfg::Box::Ptr m_Box;
	
	std::vector<BarButton*> buttons;
	//sfg::Label::Ptr m_Label1;
	//sfg::Label::Ptr m_Label2;
	sfg::Image::Ptr m_Image;
};

#endif