#ifndef NOTE_HH
#define NOTE_HH

#include <stdlib.h>
#include <string>

#include <SFGUI/SFGUI.hpp>
#include <SFML/Graphics.hpp>

class Note
{
public:
	sfg::Window::Ptr GetPointer();
	bool Init(std::string);
	void SetPosition(sf::Vector2f);
	void OnClick();
	bool Visible();
	
private:
	sfg::Window::Ptr m_Window;
	sfg::Fixed::Ptr m_Fixed;
	sfg::Label::Ptr m_Label;
};

#endif