#include "mashtextgen.h"
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
using namespace std;

MashTextGen::MashTextGen()
{
	files.push_back("BarButton.h");
	files.push_back("CreateBar.h");
	files.push_back("Eventfulness.h");
	files.push_back("GameOver.h");
	files.push_back("Glob.h");
	files.push_back("mashtextgen.h");
	files.push_back("MashWindow.h");
	files.push_back("Message.h");
	files.push_back("Note.h");
	files.push_back("NotificationBar.h");
	files.push_back("Object.h");
	files.push_back("Player.h");
	files.push_back("Render.h");
	files.push_back("RogueButton.h");
	files.push_back("RogueWindow.h");
	files.push_back("Stat.h");
	files.push_back("World.h");
	files.push_back("WorldWindow.h");
	
	files.push_back("BarButton.cpp");
	files.push_back("CreateBar.cpp");
	files.push_back("Eventfulness.cpp");
	files.push_back("GameOver.cpp");
	files.push_back("Glob.cpp");
	files.push_back("main.cpp");
	files.push_back("mashtextgen.cpp");
	files.push_back("MashWindow.cpp");
	files.push_back("Message.cpp");
	files.push_back("Note.cpp");
	files.push_back("NotificationBar.cpp");
	files.push_back("Object.cpp");
	files.push_back("Player.cpp");
	files.push_back("Render.cpp");
	files.push_back("RogueButton.cpp");
	files.push_back("RogueWindow.cpp");
	files.push_back("Stat.cpp");
	files.push_back("World.cpp");
	files.push_back("WorldWindow.cpp");
	
	LoadMoreData();
	picker = 0;
}

void MashTextGen::LoadMoreData()
{
	string line;
	ifstream myfile ( files[rand()%files.size()].c_str() );
	if (myfile.is_open())
	{
		while ( myfile.good() )
		{
			getline (myfile,line);
			alldata += line;
			alldata += "\n";
		}
		myfile.close();
	}
}

std::string MashTextGen::Get(int amount)
{
	string out = "";
	while (amount > 0)
	{
		if (picker >= alldata.size())
		{
			LoadMoreData();
		}
		else
		{
			out += alldata[picker];
			picker++;
			amount--;
		}
	}
	return out;
}